/*
 * Copyright (c) 2013, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/*!
 *  ======== Engine ========
 *  Engine Configuration interface
 */
@Template("./Engine.xdt")

metaonly module Engine {

    /*!
     *  ======== local ========
     *  Default engine used by clients of the VISA API's that pass NULL for
     *  the engine handle
     *
     *  @_nodoc
     */
    config Engine.Instance local;

    /*!
     *  ======== MAXGROUPID ========
     *  Maximum group id.
     */
    const Int MAXGROUPID = 20;


   /*!
     *  ======== initFromServer ========
     *  Allow alg tables of engines with a remote server to be populated by
     *  querying the server.
     */
    config Bool initFromServer = true;

    /*!
     *  ======== AlgDesc ========
     *  Algorithm descriptor
     *
     *  Each engine "contains" multiple algorithms described by AlgDesc
     *  structures.
     *
     *  @field(name)    This string specifies the "local" name used by the
     *                  application to identify the algorithm to instantiate
     *  @field(mod)     This field is a module reference that identifies the
     *                  actual module implementing the algorithm to instantiate
     *  @field(local)   If true, the algorithm should be instantiated on the
     *                  "local" CPU; otherwise the server will create an
     *                  instance of the algorithm identifed by `mod`.
     *  @field(groupId) This id specifies which resource sharing group
     *                  this codec will be placed into.  This 'group' concept
     *                  is used by the framework to ensure algorithms in the
     *                  same group don't pre-empt each other and corrupt the
     *                  shared resources.
     *
     *                  Note that this parameter is ignored if `local` is not
     *                  TRUE.
     */
    struct AlgDesc {
        String          name;       /*! Alg nick-name */
        ICodec.Module   mod;        /*! The alg implementation */
        Bool            local;      /*! Run algorithm locally */
        Int             groupId;    /*! Alg group ID for sharing resources */
    };

    /*!
     *  ======== createFromServer ========
     *  Create an Engine from a Server package
     *
     *  Given a Server package and an executable in that package, this method
     *  creates an Engine instance and initializes it from details in the
     *  Server provided.
     *
     *  An Engine instance created this way has all the codecs that exist
     *  in the Server executable - with codec names matching the names
     *  configured into the Server, and is configured to use an appropriate
     *  memory map and other DSP-specific info.
     *
     *  Example usage:
     *  @p(code)
     *  var myEngine = Engine.createFromServer("video_copy",
     *                     "./video_copy.x64P",
     *                     "ti.sdo.ce.examples.servers.video_copy");
     *
     *  @param(engineName)        Name to be used for the engine created
     *  @param(serverExecutable)  Path to the server executable (including the
     *                            executable), relative from server package
     *  @param(serverPackage)     Name of the server package
     *
     *  @a(returns)               An Engine instance of the same type as
     *                            if {@link #create create()} were called.
     */
    function createFromServer(engineName, serverExecutable, serverPackage);

    /*!
     *  ======== close ========
     *  Internal close method (see package.xs)
     * @_nodoc
     */
    function close();

    /*!
     *  ======== validate ========
     *  Internal validate method (see package.xs)
     * @_nodoc
     */
    function validate();

    /*!
     * ======== usesIRES ========
     * Returns true if there is an engine with a local alg that implements
     * iresFxns. This function is used to determine whether or not RMAN
     * library needs to be linked in.
     *
     * @_nodoc
     */
    bool usesIRES();

    /*!
     *  ======== hasServer ========
     *  Returns true if there is an engine with a remote alg, or an engine
     *  that uses a server.
     *
     *  @_nodoc
     */
    bool hasServer();

instance:

    /*!
     *  ======== create ========
     *  Create Engine instance
     *
     *  Parameters:
     *  @p(dlist)
     *      - `name`
     *          Name of this engine; this name is used by clients via the
     *          `Engine_open()` API to identify the collection of algorithms
     *          available.
     *
     *      - `algs`
     *          Array of algorithms this engine supports
     *
     *      - `server`
     *          Optional name of the DSP Server; this name is used (if
     *          necessary) to load and start any associated DSP CPUs required
     *          to support this Engine instance
     */
    create(String name, AlgDesc algs[]);

    /*!
     *  ======== name ========
     *  Name of the Engine
     *
     *  This string provided by the application in the `Engine_open()` call.
     */
    config String name;

    /*!
     *  ======== algs ========
     *  Array of algorithms available in the Engine
     *
     *  An array of algorithms which this Engine instance provides.  A mix
     *  of local and remote algorithms can be specified in this array.
     *
     *  {@link #createFromServer createFromServer()} can be used to populate
     *  this array with algorithms configured into a remote Server.
     *
     *  @see createFromServer
     */
    config AlgDesc algs[];

    /*!
     *  ======== server ========
     *  Optional name of a remote Server
     *
     *  This parameter is only necessary when there are algorithms configured
     *  to run remotely - i.e., their `local` field is set to false.
     *
     *  Engines containing these remote algorithms will need to set
     *  this `server` parameter to the name of the binary which should
     *  be loaded on the remote processor.
     */
    config String server;

    /*!
     *  ======== heapId ========
     *  Optional heap id to be used for this Engine
     *
     *  This is used internally, for example, by Comm_alloc().
     */
    config UInt32 heapId;

   /*!
     *  ======== useExtLoader ========
     *  In the case where the Engine has a remote server, @c useExtLoader
     *  specifies whether or not an external loader is used to load the
     *  server.
     *  If @c useExtLoader is set to false, Codec Engine will load the
     *  server when the Engine is opened.  Otherwise, it will be assumed
     *  that the server has already been loaded.
     */
    config Bool useExtLoader = false;

   /*!
     *  ======== memMap ========
     *  Optional name of file containing slave processor's memory map.
     *
     *  This parameter is only needed when Codec Engine will be loading
     *  the slave processor.
     */
    config String memMap;
}
